{ SimpFTP  by Eric W. Engler.  This is Freeware.  
  A Simple FTP Client for Delphi that uses TFtpCli VCL from
  Francois Piette. }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Ftpcli, StdCtrls, ExtCtrls, IniFiles, FileCtrl, CopyUnit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    HostNameEdit: TEdit;
    Hostname: TLabel;
    PortEdit: TEdit;
    Label2: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    SiteCB: TComboBox;
    NewSiteBut: TButton;
    Memo1: TMemo;
    Label3: TLabel;
    InitialDirEdit: TEdit;
    UserNameEdit: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    PasswordEdit: TEdit;
    ConnectBut: TButton;
    ExitBut: TButton;
    FtpClient1: TFtpClient;
    SaveProfileCB: TCheckBox;
    InitialLocalDirEdit: TEdit;
    Label6: TLabel;
    ForceLowerCB: TCheckBox;
    AutoDirCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ExitButClick(Sender: TObject);
    procedure ConnectButClick(Sender: TObject);
    procedure FtpClient1Display(Sender: TObject; var Msg: String);
    procedure FtpClient1RequestDone(Sender: TObject; RqType: TFtpRequest;
      Error: Word);
    procedure FtpClient1SessionClosed(Sender: TObject; Error: Word);
    procedure FtpClient1SessionConnected(Sender: TObject; Error: Word);
    function LookupRequest(RqType: TFtpRequest): String;
    procedure NewSiteButClick(Sender: TObject);
    procedure UpdateProfile;
    procedure ReadProfile(ProfileName: String);
    procedure SiteCBChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function StrEncrypt(const S: String): String;
    function StrDecrypt(const S: String): String;
    Function Base64Encode(Value : String) : String;
    Function Base64Decode(Value : String) : String;
    procedure UploadAll;
    procedure UploadNext;
    procedure DownloadAll;
    procedure DownloadNext;
    procedure RemoteDelete;
    procedure LocalDelete;
    procedure View;
    procedure ViewTheFile;
  private
    { Private declarations }
    MaskedPassword: String;
    IniFileName: String;
  public
    { Public declarations }
     FileNames: TStrings;
     FilesLeft: Integer;
     ViewMode: Boolean;
  end;

var
  Form1: TForm1;
  LoggedIn: Boolean;
  ViewfileName: String;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   IniFile: TIniFile;
   P: String;
   i: Integer;
begin
   PortEdit.Text:='21';
   SaveProfileCB.Checked:=True;
   ForceLowerCB.Checked:=True;
   AutoDirCB.Checked:=True;
   LoggedIn:=False;
   ViewMode:=False;

   IniFileName := LowerCase(ExtractFileName(Application.ExeName));
   IniFileName := Copy(IniFileName, 1, Length(IniFileName) - 3) + 'ini';
   IniFile := TIniFile.Create(IniFileName);
   p := IniFile.ReadString('Profiles', 'Name0','');
   i:=1;
   while p > '' do
   begin
      SiteCB.Items.Add(p);
      p := IniFile.ReadString('Profiles', 'Name' + IntToStr(i), '');
      inc(i);
   end;
   SiteCB.ItemIndex:=IniFile.ReadInteger('LastUsed','Profile',0);
   ReadProfile(SiteCB.Text);
   IniFile.Free;
   FileNames:=TStringList.Create;
end;

procedure TForm1.ExitButClick(Sender: TObject);
begin
   FtpClient1.Quit;
   Close;
end;

procedure TForm1.ConnectButClick(Sender: TObject);
var
   i: Integer;
begin
   CopyForm.RemoteDirList.Items.Clear;
   CopyForm.StringGrid1.RowCount:=1;

   if not DirectoryExists(InitialLocalDirEdit.Text) then
      ShowMessage('Error - can not select ' + InitialLocalDirEdit.Text)
   else
      chdir(InitialLocalDirEdit.Text);
   if SaveProfileCB.Checked then
      UpdateProfile;
   if FtpClient1.Connected then
      FtpClient1.Quit;
   Memo1.Lines.Clear;
   CopyForm.Memo1.Lines.Clear;
   Memo1.Lines.Add('Connecting to ' + HostnameEdit.Text + ' ...');
   CopyForm.Memo1.Lines.Add('Connecting to ' + HostnameEdit.Text + ' ...');
   Screen.Cursor:=crHourGlass;
   Application.ProcessMessages;
   MaskedPassword:='';
   for i := 1 to Length(PasswordEdit.Text) do
      MaskedPassword := MaskedPassword + '?';
   with FtpClient1 do
   begin
      Binary:=True;
      HostDirName:=InitialDirEdit.Text;
      HostName:=HostNameedit.Text;
      UserName:=UserNameEdit.Text;
      PassWord:=PasswordEdit.Text;
      Connect;
   end;
end;

procedure TForm1.FtpClient1Display(Sender: TObject; var Msg: String);
begin
   if Pos('PASS ', Msg) > 0 then
   begin
      // don't show the password on the screen
      Memo1.Lines.Add('> PASS ' + MaskedPassword);
      Copyform.Memo1.Lines.Add('> PASS ' + MaskedPassword);
   end
   else
   begin
      Memo1.Lines.Add(Msg);
      Copyform.Memo1.Lines.Add(Msg);
   end;
end;

procedure TForm1.FtpClient1RequestDone(Sender: TObject;
  RqType: TFtpRequest; Error: Word);
var
   req: String;
begin
   req:=LookupRequest(RqType);
   Memo1.Lines.Add('Done (request=' + req
         + '  error code=' + IntToStr(Error) + ')');
   CopyForm.Memo1.Lines.Add('Done (request=' + req
         + '  error code=' + IntToStr(Error) + ')');

   if Error > 0 then
      ShowMessage('Error ' + FtpClient1.ErrorMessage);

   if (RqType = ftpConnectAsync) and (Error = 0) then
   begin
      LoggedIn:=True;
      CopyForm.Caption:='Transfer Files to/from:  ' + HostnameEdit.Text;
      if InitialDirEdit.Text > '' then
         FtpClient1.Cwd   // Select initial dir on remote
      else
         FtpClient1.Pwd;  // show dir on remote
   end;

   if (RqType = ftpCwdAsync) or (RqType = ftpCDupAsync)
    or (RqType = ftpRmdAsync) or (RqType = ftpMkdAsync) then
      FtpClient1.Pwd;  // Show user the current directory

   if RqType = ftpPwdAsync then
   begin
      Screen.Cursor:=crDefault;
      CopyForm.Position:=poDesigned;
      CopyForm.Left:=Left;
      CopyForm.Top:=Top;
      CopyForm.RemoteDirEdit.Text:=FtpClient1.DirResult;
      if AutoDirCB.Checked then
      begin
         FtpClient1.HostFileName:='';  // request list of all files
         FtpClient1.LocalFileName:= WinTempDir + 'ftpdir.txt';
         if FtpClient1.Binary then
         begin
            FtpClient1.Binary:=False;
            Ftpclient1.TypeSet;
         end;
         FTPClient1.Dir;
      end
      else
         CopyForm.Show;
   end;

   if RqType = ftpDirAsync then
   begin
      CopyForm.ParseDir;
      CopyForm.Position:=poDesigned;
      CopyForm.Left:=Left;
      CopyForm.Top:=Top;
      CopyForm.Show;
   end;

   if RqType = ftpPutAsync then
   begin
      if FilesLeft = 0 then
      begin
         if AutoDirCB.Checked then
         begin
            FtpClient1.HostFileName:='';  // request list of all files
            FtpClient1.LocalFileName:= WinTempDir + 'ftpdir.txt';
            if FtpClient1.Binary then
            begin
               FtpClient1.Binary:=False;
               FtpClient1.TypeSet;
            end;
            FTPClient1.Dir;
         end
         else
            CopyForm.Show;
      end
      else
         UploadNext;
   end;

   if RqType = ftpGetAsync then
   begin
      if ViewMode then
      begin
         ViewTheFile;
         ViewMode:=False;
         Exit;
      end;
      if FilesLeft = 0 then
      begin
         CopyForm.FileListBox1.Update;
         CopyForm.Show;
      end
      else
         DownloadNext;
   end;

   if RqType = ftpDeleAsync then
   begin
      if FilesLeft = 0 then
      begin
         if AutoDirCB.Checked then
         begin
            FtpClient1.HostFileName:='';  // request list of all files
            FtpClient1.LocalFileName:= WinTempDir + 'ftpdir.txt';
            if FtpClient1.Binary then
            begin
               FtpClient1.Binary:=False;
               FtpClient1.TypeSet;
            end;
            FTPClient1.Dir;
         end
         else
            CopyForm.Show;
      end
      else
         RemoteDelete;
   end;
end;

procedure TForm1.FtpClient1SessionClosed(Sender: TObject; Error: Word);
begin
   LoggedIn:=False;
   Memo1.Lines.Add('Disconnected');
   CopyForm.Memo1.Lines.Add('Disconnected');
end;

procedure TForm1.FtpClient1SessionConnected(Sender: TObject; Error: Word);
begin
   // NOTE: This does NOT mean that you are logged in!
   Memo1.Lines.Add('Connected');
   CopyForm.Memo1.Lines.Add('Connected');
end;

procedure TForm1.NewSiteButClick(Sender: TObject);
var
   NewSite: String;
begin
   NewSite := InputBox('New FTP Site','Enter Site Profile Name','');
   if Length(NewSite) = 0 then
      exit;
   if SiteCB.Items.IndexOf(UpperCase(NewSite)) > -1 then
   begin
      ShowMessage(NewSite + ' already exists');
      SiteCB.ItemIndex:=SiteCB.Items.IndexOf(UpperCase(NewSite));
      ReadProfile(SiteCB.Text);
      exit;
   end;
   SiteCB.Items.Add(UpperCase(NewSite));
   SiteCB.ItemIndex:=SiteCB.Items.Count-1; { point to item we just added }
   HostNameEdit.Text:='';
   InitialLocalDirEdit.Text:='C:\';
   InitialDirEdit.Text:='';
   UserNameEdit.Text:='';
   PasswordEdit.Text:='';
   PortEdit.Text:='21';
   ForceLowerCB.Checked:=True;
   AutoDirCB.Checked:=True;
   if SaveProfileCB.Checked then
      UpdateProfile;
end;

procedure TForm1.UpdateProfile;
var
   IniFile: TIniFile;
   ProfileName: String;
   i: Integer;
   NewSite: String;
begin
   if SiteCB.Text = '' then
   begin
      NewSite:= InputBox('New FTP Site','Enter Site Profile Name','');
      if Length(NewSite) = 0 then
         NewSite:='UNTITLED';
      NewSite:=UpperCase(NewSite);
      // does this new site already exist?
      if SiteCB.Items.IndexOf(NewSite) = -1 then
         SiteCB.Items.Add(NewSite);
      SiteCB.ItemIndex:=SiteCB.Items.IndexOf(NewSite);
   end;
   ProfileName:=SiteCB.Text;
   // Does this profile already exist?
   i:=SiteCB.Items.IndexOf(UpperCase(ProfileName));
   if i = -1 then
      // it doesn't exist yet
      i:=SiteCB.Items.Count;

   IniFile := TIniFile.Create(IniFileName);
   IniFile.WriteString('Profiles', 'Name'+IntToStr(i), ProfileName);
   IniFile.WriteString(ProfileName, 'HostName', HostNameEdit.Text);
   IniFile.WriteString(ProfileName, 'InitialLocalDir', InitialLocalDirEdit.Text);
   IniFile.WriteString(ProfileName, 'InitialDir', InitialDirEdit.Text);
   IniFile.WriteString(ProfileName, 'UserName', UserNameEdit.Text);
   IniFile.WriteString(ProfileName, 'Password',
                       Base64Encode(strEncrypt(PasswordEdit.Text)));
   IniFile.WriteInteger(ProfileName, 'Port', StrToInt(PortEdit.Text));
   IniFile.WriteBool(ProfileName, 'ForceLower', ForceLowerCB.Checked);
   IniFile.WriteBool(ProfileName, 'AutoDir', AutoDirCB.Checked);
   IniFile.WriteInteger('LastUsed', 'Profile', i);
   IniFile.Free;
end;

procedure TForm1.ReadProfile(ProfileName: String);
var
   IniFile: TIniFile;
begin
   IniFile := TIniFile.Create(IniFileName);
   HostNameEdit.Text:=IniFile.ReadString(ProfileName, 'HostName', '');
   InitialLocalDirEdit.Text:=IniFile.ReadString(ProfileName,'InitialLocalDir','C:\');
   InitialDirEdit.Text:=IniFile.ReadString(ProfileName, 'InitialDir', '');
   UserNameEdit.Text:=IniFile.ReadString(ProfileName, 'UserName', '');
   PasswordEdit.Text:=
      StrDecrypt(Base64Decode(IniFile.ReadString(ProfileName, 'Password', '')));
   PortEdit.Text:=IntToStr(IniFile.ReadInteger(ProfileName, 'Port', 21));
   ForceLowerCB.Checked:=IniFile.ReadBool(ProfileName, 'ForceLower', True);
   AutoDirCB.Checked:=IniFile.ReadBool(ProfileName, 'AutoDir', True);
   IniFile.Free;
end;

procedure TForm1.SiteCBChange(Sender: TObject);
begin
   ReadProfile(SiteCB.Text);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
   CurSite: String;
   IniFile: TIniFile;
   i: Integer;
begin
   FileNames.Free;
   IniFile := TIniFile.Create(IniFileName);
   // Sort the site profile entries
   IniFile.EraseSection('Profiles');
   CurSite:=SiteCB.Text; // remember the current site
   SiteCB.Sorted:=True;  // sort the combo box list of profiles
   for i :=0 to SiteCB.Items.Count - 1 do
      IniFile.WriteString('Profiles', 'Name'+IntToStr(i), SiteCB.Items[i]);
   // Now that we sorted the list, we need to find where our current
   // site is in the new order:
   i:=SiteCB.Items.IndexOf(CurSite);
   if i = -1 then
      i:=0;   // we couldn't find the current site - unlikely!
   IniFile.WriteInteger('LastUsed', 'Profile', i);
   IniFile.Free;
end;

function TForm1.StrEncrypt(const S: String): String;
const
  C1 = 52845;  { well-chosen values for seeds to encryption }
  C2 = 22719;
var
  I: Integer;
  Key: Word;
begin
  Key:=7373;
 {$IFDEF Win32}
  SetLength(Result,Length(S));
 {$ELSE}
  Result[0]:=Chr(Length(S));
 {$ENDIF}
 {$R-}
 {$Q-}
  for I := 1 to Length(S) do begin
    Result[I] := char(Ord(S[I]) xor (Key shr 8));
    Key := (Ord(Result[I]) + Key) * C1 + C2;
  end;
end;

function TForm1.StrDecrypt(const S: String): String;
const
  C1 = 52845;  { well-chosen values for seeds to encryption }
  C2 = 22719;
var
  I: Integer;
  Key: Word;
begin
  Key:=7373;
 {$IFDEF Win32}
  SetLength(Result,Length(S));
 {$ELSE}
  Result[0]:=Chr(Length(S));
 {$ENDIF}
 {$R-}
 {$Q-}
  for I := 1 to Length(S) do begin
    Result[I] := char(Ord(S[I]) xor (Key shr 8));
    Key := (Ord(S[I]) + Key) * C1 + C2;
  end;
end;

// Base64 code is by Tom Bradford of Beachdog Software
Const Base64Table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

Function TForm1.Base64Encode(Value : String) : String;
Var AIn   : Array[1..3] Of Byte;
    AOut  : Array[1..4] Of Byte;
    AWork : Array[1..3] Of Byte;
    I : Integer;
    O : LongInt;
Begin
   Result := '';
   I := 1;
   O := Length(Value);
   Case Length(Value) Mod 3 Of
      1 : Value := Value + #0 + #0;
      2 : Value := Value + #0;
   End;
   While I < Length(Value) Do
      Begin
         AIn[1] := Byte(Value[I]);
         AIn[2] := Byte(Value[I+1]);
         AIn[3] := Byte(Value[I+2]);

         AOut[1] := Byte(AIn[1] Shr 2);
         AWork[1] := Byte(AIn[1] Shl 4);
         AWork[2] := Byte(AWork[1] And $30);
         AWork[3] := Byte(AIn[2] Shr 4);
         AOut[2] := Byte(AWork[2] Or AWork[3]);
         AWork[1] := Byte(AIn[2] Shl 2);
         AWork[2] := Byte(AWork[1] And $3C);
         AWork[3] := Byte(AIn[3] Shr 6);
         AOut[3] := Byte(AWork[2] Or AWork[3]);
         AOut[4] := Byte(AIn[3] And $3F);

         Inc(I, 3);
         Result := Result + Base64Table[AOut[1]+1] + Base64Table[AOut[2]+1] + Base64Table[AOut[3]+1] + Base64Table[AOut[4]+1];
      End;
   If O Mod 3 > 0 Then Result[Length(Result)] := '=';
   If O Mod 3 = 1 Then Result[Length(Result)-1] := '=';
End;

Function TForm1.Base64Decode(Value : String) : String;
Var AIn   : Array[1..4] Of Byte;
    AOut  : Array[1..3] Of Byte;
    AWork : Array[1..3] Of Byte;
    I : Integer;
    C : Integer;
Begin
   Result := '';
   I := 1;
   While I < Length(Value) Do
   Begin
      C := 3;
      FillChar(AWork, SizeOf(AWork), #0);
      FillChar(AOut, SizeOf(AWork), #0);
      AIn[1] := Byte(Pos(Value[I],Base64Table)-1);
      AIn[2] := Byte(Pos(Value[I+1],Base64Table)-1);
      AIn[3] := Byte(Pos(Value[I+2],Base64Table)-1);
      AIn[4] := Byte(Pos(Value[I+3],Base64Table)-1);
      If Value[I+3]='=' Then
      Begin
         C := 2;
         AIn[4] := 0;
         If Value[I+2]='=' Then
         Begin
            C := 1;
            AIn[3] := 0;
         End;
      End;
      AWork[2] := Byte(AIn[1] Shl 2);
      AWork[3] := Byte(AIn[2] Shr 4);
      AOut[1] := Byte(AWork[2] Or AWork[3]);
      AWork[2] := Byte(AIn[2] Shl 4);
      AWork[3] := Byte(AIn[3] Shr 2);
      AOut[2] := Byte(AWork[2] Or AWork[3]);
      AWork[2] := Byte(AIn[3] Shl 6);
      AOut[3] := Byte(AWork[2] Or AIn[4]);
      Result := Result + Char(AOut[1]);
      If C > 1 Then
         Result := Result + Char(AOut[2]);
      If C > 2 Then
         Result := Result + Char(AOut[3]);
      Inc(I, 4);
   End;
End;

procedure TForm1.UploadAll;
begin
   with FtpClient1 do
   begin
      if CopyForm.RadioGroup1.ItemIndex = 0 then
         Binary:=True
      else
         Binary:=False;
      TypeSet; // Tell the other end to use binary or ascii mode
      FilesLeft := FileNames.Count;
      UploadNext;
   end;
end;

procedure TForm1.UploadNext;
begin
   with FtpClient1 do
   begin
      Dec(FilesLeft);
      if FilesLeft > -1 then
      begin
         HostDirName:=CopyForm.RemotedirEdit.Text;
         if ForceLowerCB.Checked then
            HostFileName:=Lowercase(ExtractFileName(FileNames.Strings[FilesLeft]))
         else
            HostFileName:=ExtractFileName(FileNames.Strings[FilesLeft]);
         LocalFileName:=FileNames.Strings[FilesLeft];
         Memo1.Lines.Add('put ' + LocalFileName + ' ' + HostFileName);
         CopyForm.Memo1.Lines.Add('put ' + LocalFileName + ' ' + HostFileName);
         Put;
      end;
   end;
end;

procedure TForm1.View;
begin
   with FtpClient1 do
   begin
      Binary:=False;
      TypeSet; // Tell the other end to use ascii mode
      FilesLeft := FileNames.Count;
      HostDirName:=CopyForm.RemotedirEdit.Text;
      ViewFileName:=FileNames.Strings[0];
      LocalFileName:=WinTempDir + ViewFileName;
      HostFileName:=ViewFileName;
      Memo1.Lines.Add('get ' + HostFileName + ' ' + LocalFileName);
      CopyForm.Memo1.Lines.Add('get ' + HostFileName + ' ' + LocalFileName);
      Get;
   end;
end;

procedure TForm1.ViewTheFile;
var
   zAppName:array[0..512] of char;
   zCurDir:array[0..255] of char;
   WorkDir:String;
   StartupInfo:TStartupInfo;
   ProcessInfo:TProcessInformation;
begin
   if not FileExists(WinTempDir + ViewFileName) then
      Exit;
   // The filename arg for Wordpad has double quotes around it
   StrPCopy(zAppName, 'C:\PROGRA~1\ACCESS~1\wordpad.exe "'
                    + WinTempDir + ViewFileName + '"');
   GetDir(0,WorkDir);
   StrPCopy(zCurDir,WorkDir);
   FillChar(StartupInfo,Sizeof(StartupInfo),#0);
   StartupInfo.cb := Sizeof(StartupInfo);
   StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
   StartupInfo.wShowWindow := SW_SHOWDEFAULT;
   if not CreateProcess(nil,
      zAppName,                      { pointer to command line string }
      nil,                           { pointer to process security attributes }
      nil,                           { pointer to thread security attributes }
      false,                         { handle inheritance flag }
      CREATE_NEW_CONSOLE or          { creation flags }
      NORMAL_PRIORITY_CLASS,
      nil,                           { pointer to new environment block }
      nil,                           { pointer to current directory name }
      StartupInfo,                   { pointer to STARTUPINFO }
      ProcessInfo) then
         ShowMessage('Error spawning wordpad.exe') { pointer to PROCESS_INF }
   else
   begin
      WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
      //GetExitCodeProcess(ProcessInfo.hProcess,Result);
   end;
   DeleteFile(WinTempDir + ViewFileName);
end;

procedure TForm1.DownloadAll;
begin
   with FtpClient1 do
   begin
      if CopyForm.RadioGroup1.ItemIndex = 0 then
         Binary:=True
      else
         Binary:=False;
      TypeSet; // Tell the other end to use binary or ascii mode
      FilesLeft := FileNames.Count;
      DownLoadNext;
   end;
end;

procedure TForm1.DownloadNext;
begin
   with FtpClient1 do
   begin
      Dec(FilesLeft);
      if FilesLeft > -1 then
      begin
         HostDirName:=CopyForm.RemotedirEdit.Text;
         if ForceLowerCB.Checked then
            LocalFileName:=CopyForm.AppendSlash(CopyForm.DirectoryListBox1.Directory)
               + Lowercase(FileNames.Strings[FilesLeft])
         else
            LocalFileName:=CopyForm.AppendSlash(CopyForm.DirectoryListBox1.Directory)
               + FileNames.Strings[FilesLeft];
         HostFileName:=FileNames.Strings[FilesLeft];
         Memo1.Lines.Add('get ' + HostFileName + ' ' + LocalFileName);
         CopyForm.Memo1.Lines.Add('get ' + HostFileName + ' ' + LocalFileName);
         Get;
      end;
   end;
end;

procedure TForm1.RemoteDelete;
begin
   with FtpClient1 do
   begin
      Dec(FilesLeft);
      if FilesLeft > -1 then
      begin
         HostDirName:=CopyForm.RemotedirEdit.Text;
         HostFileName:=FileNames.Strings[FilesLeft];
         Memo1.Lines.Add('Del ' + HostFileName + ' ' + LocalFileName);
         CopyForm.Memo1.Lines.Add('Del ' + HostFileName + ' ' + LocalFileName);
         Dele;
      end;
   end;
end;

procedure TForm1.LocalDelete;
begin
   while FilesLeft > 0 do
   begin
      Dec(FilesLeft);
      DeleteFile(FileNames.Strings[FilesLeft]);
      Memo1.Lines.Add('Del ' + FileNames.Strings[FilesLeft]);
      CopyForm.Memo1.Lines.Add('Del ' + FileNames.Strings[FilesLeft]);
   end;
   CopyForm.FileListBox1.Update;
   CopyForm.Show;
end;

function TForm1.LookupRequest(RqType: TFtpRequest): String;
begin
   case RqType of
      ftpNone: result:='none';
      ftpOpenAsync: result:='OpenAsync';
      ftpUserAsync: result:='UserAsync';
      ftpPassAsync: result:='PassAsync';
      ftpCwdAsync: result:='CwdAsync';
      ftpConnectAsync: result:='ConnectAsync';
      ftpReceiveAsync: result:='ReceiveAsync';
      ftpDirAsync: result:='DirAsync';
      ftpLsAsync: result:='LsAsync';
      ftpPortAsync: result:='PortAsync';
      ftpGetAsync: result:='GetAsync';
      ftpDirectoryAsync: result:='DirectoryAsync';
      ftpListAsync: result:='ListAsync';
      ftpSystemAsync: result:='SystemAsync';
      ftpSystAsync: result:='SystAsync';
      ftpQuitAsync: result:='QuitAsync';
      ftpSizeAsync: result:='SizeAsync';
      ftpPutAsync: result:='PutAsync';
      ftpAppendAsync: result:='AppendAsync';
      ftpFileSizeAsync: result:='FileSizeAsync';
      ftpRqAbort: result:='RqAbort';
      ftpMkdAsync: result:='MkdAsync';
      ftpRmdAsync: result:='RmdAsync';
      ftpRenameAsync: result:='RenameAsync';
      ftpDeleAsync: result:='DeleAsync';
      ftpRenAsync: result:='RenAsync';
      ftpRenToAsync: result:='RenToAsync';
      ftpRenFromAsync: result:='RenFromAsync';
      ftpDeleteAsync: result:='DeleteAsync';
      ftpMkdirAsync: result:='MkdirAsync';
      ftpRmdirAsync: result:='RmdirAsync';
      ftpPwdAsync: result:='PwdAsync';
      ftpQuoteAsync: result:='QuoteAsync';
      ftpCDupAsync: result:='CDupAsync';
      ftpDoQuoteAsync: result:='DoQuoteAsync';
      ftpTransmitAsync: result:='TransmitAsync';
      ftpTypeSetAsync: result:='TypeSetAsync';
      ftpRestAsync: result:='RestAsync';
      ftpRestGetAsync: result:='RestGetAsync';
      ftpRestartGetAsync: result:='RestartGetAsync';
   else
      result:='unknown';
   end;
end;

end.
